local CTABroker = {	--Table contenant les frames
	Windows = {},	--Windows
	Headers = {},	--Headers
	CB = {},		--CheckButton
	Sliders = {},	--Sliders
	Buttons = {},	--Buttons
	DDM = {},		--DropDownMenu
	};
local CTABrokerFunction = {};	--Table contenant les fonctions

local version = 1.12;

local DungeonsId = {
	--Dungeons
	[2087] = "CTA_HSL",
	[2086] = "CTA_NSL",	
	[1671] = "CTA_HBfA",
	[744] = "CTA_TWBC",
	[995] = "CTA_TWWotlk",
	[1146] = "CTA_TWCata",
	[1453] = "CTA_TWMoP",
	[1971] = "CTA_TWWoD",
	--Legion timewalking
	--Raids
	[1731] = "CTA_Uldir1",	
	[1732] = "CTA_Uldir2",	
	[1733] = "CTA_Uldir3",	
	[1945] = "CTA_Dazar1",	
	[1946] = "CTA_Dazar2",
	[1947] = "CTA_Dazar3",
	[1948] = "CTA_Dazar1",	
	[1949] = "CTA_Dazar2",
	[1950] = "CTA_Dazar3",	
	[1951] = "CTA_Creuset",	
	[2009] = "CTA_Palais1",	
	[2010] = "CTA_Palais2",	
	[2011] = "CTA_Palais3",
	[2036] = "CTA_Nzoth1",
	[2037] = "CTA_Nzoth2",
	[2038] = "CTA_Nzoth3",
	[2039] = "CTA_Nzoth4",
	[2090] = "CTA_Nat1",
	[2091] = "CTA_Nat2",
	[2092] = "CTA_Nat3",
	[2096] = "CTA_Nat4",
	[2221] = "CTA_SD1",
	[2222] = "CTA_SD2",
	[2223] = "CTA_SD3",
	[2224] = "CTA_SD4",	
	[2292] = "CTA_SoF1",	
	[2291] = "CTA_SoF2",	
	[2293] = "CTA_SoF3",	
	[2294] = "CTA_SoF4",
	[2345] = "CTA_SoF1_Fated",
	[2346] = "CTA_SoF2_Fated",
	[2347] = "CTA_SoF3_Fated",
	[2348] = "CTA_SoF4_Fated",
	};

local FlagCTA = {};
for key, value in pairs(DungeonsId) do
	FlagCTA[value] = {
		T = 0,
		H = 0,
		D = 0,
		};
end

local SoundsA = {
	62734,	--C_Draenei F
	62735,	--C_Draenei M
	77013,	--C_Nain F
	77004,	--C_Nain M
	74682,	--C_Worgen F
	74687,	--C_Worgen M
	62736,	--C_Gnome F
	77022,	--C_Gnome M
	74679,	--C_Humain F
	74681,	--C_Humain M
	61525,	--C_Elfe de la nuit DH F
	74695,	--C_Elfe de la nuit DH M
	62739,	--C_Elf de la nuit F
	76956,	--C_Elf de la nuit M	
	62742,	--C_Pandaren F
	62744,	--C_Pandaren M
	101883,	--C_Nain Sombrefer F
	101957,	--C_Nain Sombrefer M		
	96242,	--C_Draenei Sancteforge M
	96174,	--C_Draenei Sancteforge F
	95660,	--C_Elfe du vide M
	95848,	--C_Elfe du vide F
	127032,	--C_KulTiras F
	127126,	--C_KulTiras M
	144270,	--C_Mechagnome F
	143887,	--C_Mechagnome M	
	};
local SoundsH = {
	62732,	--Elfe de sang F
	62733,	--Elfe de sang H
	62737,	--Gobelin F
	62738,	--Gobelin M
	62740,	--Orc F
	62741,	--Orc M
	62743,	--Pandaren F
	62745,	--Pandaren M
	76986,	--Troll M
	74691,	--Troll F
	61526,	--Elfe de sang DH F
	61524,	--Elfe de sang DH M
	95834,	--Tauren High M
	95538,	--Tauren High F
	62746,	--Tauren F
	74674,	--Tauren M
	62748,	--Mort Vivant M
	62747,	--Mort Vivant F
	110319,	--Orc Maghar F
	110394,	--Orc Maghar M	
	96310,	--Sacrenuit F
	96378,	--Sacrenuit M
	127313,	--Troll Zandalari M
	126939,	--Troll Zandalari F	
	144109,	--Vulperin M		
	144014,	--Vulperin F	
	
	};	
	
local Sounds = {};

local L = {};		--Table pour la localisation
local anchorpoint = {		--Table pour l'ancrage de la tooltip
	"TOP",
	"TOPLEFT",
	"LEFT",
	"BOTTOMLEFT",
	"BOTTOM",
	"BOTTOMRIGHT",
	"RIGHT",
	"TOPRIGHT",
};
local info = {};	--Pour la création des DDM

local ONUPDATE_INTERVAL = 10	-- The minimum number of seconds between each update
local TimeSinceLastUpdate = 0	-- The number of seconds since the last update

-------------------------------------------------------------------------------------------------------------
----------------- Slash Command -----------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

local CTABrokerCommandTable = {
	["options"] = function()
		CTABrokerFunction:Options();
		end,
	};

function CTABrokerFunction:DispatchCommand(message, commandTable)
	local command, parameters = string.split(" ", message, 2)
	local entry = commandTable[command:lower()]		--retire toutes les majuscules
	local which = type(entry)
	
	if which == "function" then
		entry(parameters)
	elseif which == "table" then
		DispatchCommand(parameters or "", entry)
	elseif which == "string" then
		print(entry)
	end
end

SLASH_CTABROKER1 = '/ctabroker' ;
SlashCmdList["CTABROKER"] = function(msg)
	CTABrokerFunction:DispatchCommand(msg, CTABrokerCommandTable);
end

function CTABrokerFunction:Options()
	if CTABroker.CTA_Option == nil then
		CTABrokerFunction:OptionsPanel();
		CTABroker.CTA_Option:Hide();		
	end
	
	if CTABroker.CTA_Option:IsShown() then
		CTABroker.CTA_Option:Hide();
	else
		CTABroker.CTA_Option:Show();	
	end
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Fonctions générales --------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

--Création d'une frame complète
function CTABrokerFunction:CreateFrameOne(name, ParentFrame, xSize, ySize, SetPointOne, SetPointParent, xOffset1, yOffset1, file)
	local t = CreateFrame("Frame" , name, ParentFrame);
	t:SetSize(xSize, ySize); --Définir la taille de la frame(largueur/hauteur)
	t:SetPoint(SetPointOne, ParentFrame, SetPointParent, xOffset1, yOffset1); --Position de la frame 
	t:SetFrameStrata("HIGH"); --Couche sur laquelle la frame est placée
	-- Texture de la frame (pour le fond)
	t.Texture = t:CreateTexture(nil, "BACKGROUND");
	t.Texture:SetAllPoints(t);
	t.Texture:SetTexture(file);
	return t;
end

-------------------------------------------------------------------------------------------------------------
----------------- Traduction --------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------

local Lfrench = {
	["sound"] = "Son",	
	["enable"] = "Activer",	
	["editboxiconsize"] = "Taille des icônes (entre 10 et 50) : ",
	["move"] = "Déplacer",
	["unmove"] = "Sauvegarder la position",
	["move1"] = "Déplacer la fenêtre de notifications",	
	["anchoring"] = "Ancrage de la tooltip par rapport à l'icône de rôle",	
	["tooltipanchor"] = "Point d'ancrage de la tooltip",	
	["iconanchor"] = "Point d'ancrage de l'icône de role",	
	
	
	
	["move cta"] = "Déplacer",
	["Appels aux Armes"] = "Appels aux Armes",	

	["unmove1"] = "CTABroker : Position de la fenêtre sauvegardée",

	["size1"] = "CTABroker : La valeur saisie n'est pas comprise entre 10 et 50",
	["options1"] = "Les valeurs enregistrées sont :",
	["options2"] = "Son : On",
	["options3"] = "Son : Off",
	["options4"] = "Le point d'ancrage de la Tooltip est : ",
	["options5"] = "Le point d'ancrage de l'icône est : ",
	["options6"] = "La taille des icônes est réglée sur : ",	
};

local Lenglish = {
	["sound"] = "Sound",	
	["enable"] = "Enable",
	["editboxiconsize"] = "Icon size (between 10 and 50) : ",
	["move"] = "Move",
	["unmove"] = "Save the position",
	["move1"] = "Move the popup frame",	
	["anchoring"] = "Position of the tooltip frame from the icon role",
	["tooltipanchor"] = "Anchor point of the tooltip",
	["iconanchor"] = "Anchor point of the icon role",
	
	
	["move cta"] = "Move",
	["Appels aux Armes"] = "Call to Arms",

	["unmove1"] = "CTABroker : Position of the frame saved",

	["size1"] = "CTABroker : The value must be between 10 and 50",
	["options1"] = "The values saved are :",
	["options2"] = "Sound : On",
	["options3"] = "Sound : Off",
	["options4"] = "The anchor point of the tooltip is : ",
	["options5"] = "The anchor point of the icon is : ",
	["options6"] = "The size of the icons is set on : ",	
};

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Main Program ---------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

function CTABrokerFunction:Main()
	local top = CTABrokerDB.anchortop
	local left = CTABrokerDB.anchorleft
	local sound = CTABrokerDB.sound
	local size = CTABrokerDB.size
	
	--Frame de scan
		CTABroker.CTA_Scan = CreateFrame("Frame", "CTABrokerFrameScan", UIParent);
	--Frame d'ancrage
		--Frame
		CTABroker.CTA_Anchor = CreateFrame("Frame" , "CTABrokerFrameAnchor", UIParent);
		CTABroker.CTA_Anchor:SetSize(3*size, size); --Définir la taille de la frame(largueur/hauteur)
		CTABroker.CTA_Anchor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", left, top); --Position de la frame 
		CTABroker.CTA_Anchor:SetFrameStrata("HIGH"); --Couche sur laquelle la frame est placée	
		--Texture
		CTABroker.CTA_Anchor.Texture = CTABroker.CTA_Anchor:CreateTexture(nil, "BACKGROUND");
		CTABroker.CTA_Anchor.Texture:SetAllPoints(CTABroker.CTA_Anchor);
		CTABroker.CTA_Anchor.Texture:SetColorTexture(1, 0, 0, 1);	
		CTABroker.CTA_Anchor:Hide();
		--Title
		CTABroker.CTA_Anchor.Title = CTABroker.CTA_Anchor:CreateFontString(nil, "OVERLAY");
		CTABroker.CTA_Anchor.Title:SetFontObject("GameFontHighlight");
		CTABroker.CTA_Anchor.Title:SetPoint("CENTER", CTABroker.CTA_Anchor, "CENTER", 0, 0);
		CTABroker.CTA_Anchor.Title:SetText(L["move cta"]);		
	--Frame des rôles
		CTABroker.CTA_T = CTABrokerFunction:CreateFrameOne("CTABrokerFrameTank", UIParent, size, size, "TOPLEFT", "BOTTOMLEFT", left, top, "Interface\\AddOns\\CTABroker\\Fonts\\tank");
		CTABroker.CTA_H = CTABrokerFunction:CreateFrameOne("CTABrokerFrameHeal", UIParent, size, size, "TOPLEFT", "BOTTOMLEFT", left+size, top, "Interface\\AddOns\\CTABroker\\Fonts\\heal");	
		CTABroker.CTA_D = CTABrokerFunction:CreateFrameOne("CTABrokerFrameDps", UIParent, size, size, "TOPLEFT", "BOTTOMLEFT", left+2*size, top, "Interface\\AddOns\\CTABroker\\Fonts\\dps");
		CTABroker.CTA_T:Hide();
		CTABroker.CTA_H:Hide();
		CTABroker.CTA_D:Hide();
	
	--Scanning
	CTABroker.CTA_Scan:SetScript("OnUpdate", function(self, elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		if TimeSinceLastUpdate >= ONUPDATE_INTERVAL then
			--Do stuff
			RequestLFDPlayerLockInfo();
			TimeSinceLastUpdate = 0;
		end
	end)
		
	--Tooltip Tank
	CTABroker.CTA_T:SetScript("OnEnter", function()
		CTABrokerFunction:Tooltip("Tank");
		end);
	CTABroker.CTA_T:SetScript("OnLeave", function()
		GameTooltip:Hide();
		end);
	--Tooltip Heal
	CTABroker.CTA_H:SetScript("OnEnter", function()
		CTABrokerFunction:Tooltip("Heal");
		end);
	CTABroker.CTA_H:SetScript("OnLeave", function()
		GameTooltip:Hide();
		end);
	--Tooltip Dps
	CTABroker.CTA_D:SetScript("OnEnter", function()
		CTABrokerFunction:Tooltip("Dps");
		end);
	CTABroker.CTA_D:SetScript("OnLeave", function()
		GameTooltip:Hide();
		end);	
end

function CTABrokerFunction:Checking(id)
	local name = DungeonsId[id];
	local flagt, flagh, falgd = 0, 0, 0;
	
	for x=1, LFG_ROLE_NUM_SHORTAGE_TYPES, 1 do
		local eligible, forTank, forHealer, forDamage, itemCount, money, xp = GetLFGRoleShortageRewards(id, x)
		if eligible and forTank and (itemCount>0) then
			flagt = 1;
		end
		if eligible and forHealer and (itemCount>0) then
			flagh = 1;
		end
		if eligible and forDamage and (itemCount>0) then
			falgd = 1;
		end		
	end
	
	--Tank
	if flagt == 1 then
		if (FlagCTA[name]["T"] == 0) and CTABrokerDB.sound then
			--print("Tank : "..name);													--control
			PlaySound(Sounds[math.random(1,26)], "Master");
		end
		FlagCTA[name]["T"] = 1;
	else
		FlagCTA[name]["T"] = 0;
	end
	--Heal
	if flagh == 1 then
		if (FlagCTA[name]["H"] == 0) and CTABrokerDB.sound then
			--print("Heal : "..name);													--control		
			PlaySound(Sounds[math.random(1,26)], "Master");
		end
		FlagCTA[name]["H"] = 1;
	else
		FlagCTA[name]["H"] = 0;
	end	
	--Dps
	if falgd == 1 then
		if (FlagCTA[name]["D"] == 0) and CTABrokerDB.sound then
			--print("Dps : "..name);													--control			
			PlaySound(Sounds[math.random(1,26)], "Master");
		end
		FlagCTA[name]["D"] = 1;
	else
		FlagCTA[name]["D"] = 0;
	end		
end

function CTABrokerFunction:Display()
	local flagt, flagh, flagd = 0, 0, 0;	--Pour détecter un CTA

	for key, value in pairs(FlagCTA) do
		if value.T == 1 then
			flagt = 1;
		end
		if value.H == 1 then
			flagh = 1;
		end
		if value.D == 1 then
			flagd = 1;
		end		
	end
	
	-- print("Nouveau scan");							--control
	-- print(flagt.." - "..flagh.." - "..flagd);
	
	if flagt == 1 then
		CTABroker.CTA_T:Show();
	else
		CTABroker.CTA_T:Hide();
	end
	if flagh == 1 then
		CTABroker.CTA_H:Show();
	else
		CTABroker.CTA_H:Hide();	
	end
	if flagd == 1 then
		CTABroker.CTA_D:Show();
	else
		CTABroker.CTA_D:Hide();
	end
end

function CTABrokerFunction:Tooltip(role)
    local frame
	if role == "Tank" then
		frame = CTABroker.CTA_T;
	elseif role == "Heal" then
		frame = CTABroker.CTA_H;	
	else
		frame = CTABroker.CTA_D;	
	end
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:SetPoint(string.upper(CTABrokerDB.tooltip), frame, string.upper(CTABrokerDB.icon));
	
    GameTooltip:AddDoubleLine(L["Appels aux Armes"], role, 1, 1, 1, 1 ,1, 1);
    GameTooltip:AddLine(" ", 1, 1, 1);
	for key, value in pairs(FlagCTA) do
		if value[string.sub(role,1,1)] == 1 then
			for key1, value1 in pairs(DungeonsId) do
				if key == value1 then
					local name, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, name2, _ = GetLFGDungeonInfo(tonumber(key1));
						if name2 ~= "" then
							GameTooltip:AddDoubleLine(name2, name, 1, 1, 1, 1 ,1, 1);
						else
							GameTooltip:AddLine(name, 1, 1, 1);						
						end					
				end								
			end
		end
	end
	
	GameTooltip:Show();
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Menu Option ----------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

function CTABrokerFunction:OptionsPanel()
	--Fenêtre principale
	CTABroker.CTA_Option = CreateFrame("Frame", "CTABrokerFrameOptions", UIParent);
	CTABroker.CTA_Option:SetSize(600, 250); --Définir la taille de la frame(largueur/hauteur)
	CTABroker.CTA_Option:SetPoint("CENTER", UIParent, "CENTER", 0, 0); --Position de la frame 
	CTABroker.CTA_Option:SetFrameStrata("HIGH"); --Couche sur laquelle la frame est placée
	-- Texture1 de la frame (pour le fond)
	CTABroker.CTA_Option.Texture1 = CTABroker.CTA_Option:CreateTexture(nil, "BACKGROUND");
	CTABroker.CTA_Option.Texture1:SetAllPoints(CTABroker.CTA_Option);
	CTABroker.CTA_Option.Texture1:SetColorTexture(0, 0, 0, 0.8);
	-- Titre de la frame (Title1)
	CTABroker.CTA_Option.Title1 = CTABroker.CTA_Option:CreateFontString(nil, "OVERLAY");
	CTABroker.CTA_Option.Title1:SetFontObject("GameFontHighlight");
	CTABroker.CTA_Option.Title1:SetPoint("CENTER", CTABroker.CTA_Option, "TOP", 0, -10);
	CTABroker.CTA_Option.Title1:SetText("CTA Broker "..tostring(version).." - Options");
	
	--Close Button
	CTABroker.Buttons["CloseOptions"] = CreateFrame("Button", "CTABrokerCloseOptionsButton", CTABroker.CTA_Option, "UIPanelCloseButton");
	CTABroker.Buttons["CloseOptions"]:SetPoint("TOPRIGHT", CTABroker.CTA_Option, "TOPRIGHT", -2, -2);
	
	--CB Sound
	CTABroker.CB.Sound = CreateFrame("CheckButton", "CTABrokerCBSound", CTABroker.CTA_Option, "ChatConfigCheckButtonTemplate");
	CTABroker.CB.Sound:SetPoint("TOPLEFT", CTABroker.CTA_Option, "TOPLEFT", 10, -20);
	CTABroker.CB.Sound:SetChecked(CTABrokerDB.sound);	
	CTABroker.CB.Sound["Title"] = CTABroker.CB.Sound:CreateFontString(nil, "OVERLAY");
	CTABroker.CB.Sound["Title"]:SetFontObject("GameFontHighlight");
	CTABroker.CB.Sound["Title"]:SetPoint("LEFT", CTABroker.CB.Sound, "RIGHT", 5, 0);
	CTABroker.CB.Sound["Title"]:SetText(L["sound"]);
	CTABroker.CB.Sound:SetScript("OnClick", function()
		CTABrokerDB.sound = not CTABrokerDB.sound;
		end);
		
	--Taille de l'icône (Title 2)
		--Bouton "ajouter"
	CTABroker.Buttons["IconSizePlus"] = CreateFrame("Button", "CTABrokerIconSizePlus", CTABroker.CTA_Option);
	CTABroker.Buttons["IconSizePlus"]:SetSize(20, 20);
	CTABroker.Buttons["IconSizePlus"]:SetPoint("TOPLEFT", CTABroker.CB.Sound, "BOTTOMLEFT", 0, -10);	
	CTABroker.Buttons["IconSizePlus"]:SetNormalTexture("Interface\\AddOns\\CTABroker\\Fonts\\UI-PlusButton-Up");
	CTABroker.Buttons["IconSizePlus"]:SetPushedTexture("Interface\\AddOns\\CTABroker\\Fonts\\UI-PlusButton-Down");	
	CTABroker.Buttons["IconSizePlus"]:SetScript("OnClick", function()
		if CTABrokerDB.size < 50 then
			CTABrokerDB.size = CTABrokerDB.size + 1;
		end
		CTABroker.CTA_Option.Title2:SetText(L["editboxiconsize"]..CTABrokerDB.size);
		CTABroker.CTA_Anchor:SetSize(3*CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_T:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_H:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_D:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_Option.Texture2:SetSize(CTABrokerDB.size, CTABrokerDB.size);		
		end)
		--Bouton "enlever"
	CTABroker.Buttons["IconSizeMinus"] = CreateFrame("Button", "CTABrokerIconSizeMinus", CTABroker.CTA_Option);
	CTABroker.Buttons["IconSizeMinus"]:SetSize(20, 20);
	CTABroker.Buttons["IconSizeMinus"]:SetPoint("LEFT", CTABroker.Buttons["IconSizePlus"], "RIGHT", 10, 0);	
	CTABroker.Buttons["IconSizeMinus"]:SetNormalTexture("Interface\\AddOns\\CTABroker\\Fonts\\UI-MinusButton-Up");
	CTABroker.Buttons["IconSizeMinus"]:SetPushedTexture("Interface\\AddOns\\CTABroker\\Fonts\\UI-MinusButton-Down");	
	CTABroker.Buttons["IconSizeMinus"]:SetScript("OnClick", function()	
		if CTABrokerDB.size > 10 then
			CTABrokerDB.size = CTABrokerDB.size - 1;
		end
		CTABroker.CTA_Option.Title2:SetText(L["editboxiconsize"]..CTABrokerDB.size);
		CTABroker.CTA_Anchor:SetSize(3*CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_T:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_H:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_D:SetSize(CTABrokerDB.size, CTABrokerDB.size);
		CTABroker.CTA_Option.Texture2:SetSize(CTABrokerDB.size, CTABrokerDB.size);		
		end)
		--Texte explicatif
	CTABroker.CTA_Option.Title2 = CTABroker.CTA_Option:CreateFontString(nil, "OVERLAY");
	CTABroker.CTA_Option.Title2:SetFontObject("GameFontHighlight");
	CTABroker.CTA_Option.Title2:SetPoint("LEFT", CTABroker.Buttons["IconSizeMinus"], "RIGHT", 10, 0);
	CTABroker.CTA_Option.Title2:SetText(L["editboxiconsize"]..CTABrokerDB.size);
		--Icône témoin
	CTABroker.CTA_Option.Texture2 = CTABroker.CTA_Option:CreateTexture(nil, "BORDER");
	CTABroker.CTA_Option.Texture2:SetSize(CTABrokerDB.size, CTABrokerDB.size);
	CTABroker.CTA_Option.Texture2:SetPoint("LEFT", CTABroker.CTA_Option.Title2, "RIGHT", 10, 0);
	CTABroker.CTA_Option.Texture2:SetTexture("Interface\\AddOns\\CTABroker\\Fonts\\tank");
	
	--Déplacement de la fenêtre
	CTABroker.Buttons["FrameMove"] = CreateFrame("Button", "CTABrokerFrameMove", CTABroker.CTA_Option, "GameMenuButtonTemplate");
	CTABroker.Buttons["FrameMove"]:SetPoint("TOPLEFT", CTABroker.Buttons["IconSizePlus"], "BOTTOMLEFT", 0, -10);
	CTABroker.Buttons["FrameMove"]:SetSize(70, 20);
	CTABroker.Buttons["FrameMove"]:SetText(L["move"]);
	CTABroker.Buttons["FrameMove"]:SetScript("OnClick", function()
		CTABroker.CTA_Option:Hide();
		CTABroker.CTA_T:Hide();
		CTABroker.CTA_H:Hide();
		CTABroker.CTA_D:Hide();				
		CTABroker.CTA_Anchor:Show();
		CTABroker.Buttons["FrameUnmove"]:Show();		
		--Déplacement de la fenêtre
		CTABroker.CTA_Anchor:SetScript("OnMouseDown", function() 
			CTABroker.CTA_Anchor:SetMovable(true); --Autorisation de déplacer la fenêtre
			CTABroker.CTA_Anchor:StartMoving();
			end) --Autorisation
		CTABroker.CTA_Anchor:SetScript("OnMouseUp", function() 
			CTABrokerDB.anchorleft = CTABroker.CTA_Anchor:GetLeft();
			CTABrokerDB.anchortop = CTABroker.CTA_Anchor:GetTop();
			CTABroker.CTA_Anchor:StopMovingOrSizing();
			CTABroker.CTA_Anchor:ClearAllPoints();
			CTABroker.CTA_Anchor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", CTABrokerDB.anchorleft, CTABrokerDB.anchortop);
			CTABroker.CTA_T:ClearAllPoints();
			CTABroker.CTA_T:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", CTABrokerDB.anchorleft, CTABrokerDB.anchortop);
			CTABroker.CTA_H:ClearAllPoints();
			CTABroker.CTA_H:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", CTABrokerDB.anchorleft+CTABrokerDB.size, CTABrokerDB.anchortop);			
			CTABroker.CTA_D:ClearAllPoints();
			CTABroker.CTA_D:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", CTABrokerDB.anchorleft+2*CTABrokerDB.size, CTABrokerDB.anchortop);						
			end) --Blocage		
		end);
	CTABroker.Buttons["FrameUnmove"] = CreateFrame("Button", "CTABrokerFrameUnmove", UIParent, "GameMenuButtonTemplate");
	CTABroker.Buttons["FrameUnmove"]:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	CTABroker.Buttons["FrameUnmove"]:SetSize(300, 30);
	CTABroker.Buttons["FrameUnmove"]:SetText(L["unmove"]);
	CTABroker.Buttons["FrameUnmove"]:Hide();	
	CTABroker.Buttons["FrameUnmove"]:SetScript("OnClick", function()
 		CTABroker.CTA_Option:Show();
		CTABroker.Buttons["FrameUnmove"]:Hide();
		CTABroker.CTA_Anchor:Hide();
		end);
	CTABroker.Buttons["FrameMove"]["Title"] = CTABroker.Buttons["FrameMove"]:CreateFontString(nil, "OVERLAY");
	CTABroker.Buttons["FrameMove"]["Title"]:SetFontObject("GameFontHighlight");
	CTABroker.Buttons["FrameMove"]["Title"]:SetPoint("LEFT", CTABroker.Buttons["FrameMove"], "RIGHT", 10, 0);
	CTABroker.Buttons["FrameMove"]["Title"]:SetText(L["move1"]);	
	
	
	--Ancrage de la Tooltip (Title3)
	CTABroker.CTA_Option.Title3 = CTABroker.CTA_Option:CreateFontString(nil, "OVERLAY");
	CTABroker.CTA_Option.Title3:SetFontObject("GameFontHighlight");
	CTABroker.CTA_Option.Title3:SetPoint("TOPLEFT", CTABroker.Buttons["FrameMove"], "BOTTOMLEFT", 0, -20);
	CTABroker.CTA_Option.Title3:SetText(L["anchoring"]);	
		--DDM pour la Tooltip
	CTABroker.DDM.Tooltip = CreateFrame("Frame", "CTABrokerDDMTooltip", CTABroker.CTA_Option, "UIDropDownMenuTemplate");
	CTABroker.DDM.Tooltip:SetPoint("TOPLEFT", CTABroker.CTA_Option.Title3, "BOTTOMLEFT", 10, -10);
	UIDropDownMenu_Initialize(CTABroker.DDM.Tooltip, function(self, level, menuList) CTABrokerFunction:DDMRealmSelection_InitializeTooltip(self, level) end);
	UIDropDownMenu_SetWidth(CTABroker.DDM.Tooltip, 100);
	UIDropDownMenu_SetButtonWidth(CTABroker.DDM.Tooltip, 124);
	UIDropDownMenu_SetText(CTABroker.DDM.Tooltip, CTABrokerDB.tooltip);
	UIDropDownMenu_JustifyText(CTABroker.DDM.Tooltip, "LEFT");	
	CTABroker.DDM.Tooltip.Title = CTABroker.DDM.Tooltip:CreateFontString(nil, "OVERLAY");
	CTABroker.DDM.Tooltip.Title:SetFontObject("GameFontHighlight");
	CTABroker.DDM.Tooltip.Title:SetPoint("LEFT", CTABroker.DDM.Tooltip, "RIGHT", 10, 0);
	CTABroker.DDM.Tooltip.Title:SetText(L["tooltipanchor"]);
		--DDM pour l'icône
	CTABroker.DDM.Icon = CreateFrame("Frame", "CTABrokerDDMIcon", CTABroker.CTA_Option, "UIDropDownMenuTemplate");
	CTABroker.DDM.Icon:SetPoint("TOPLEFT", CTABroker.DDM.Tooltip, "BOTTOMLEFT", 0, -10);
	UIDropDownMenu_Initialize(CTABroker.DDM.Icon, function(self, level, menuList) CTABrokerFunction:DDMRealmSelection_InitializeIcon(self, level) end);
	UIDropDownMenu_SetWidth(CTABroker.DDM.Icon, 100);
	UIDropDownMenu_SetButtonWidth(CTABroker.DDM.Icon, 124);
	UIDropDownMenu_SetText(CTABroker.DDM.Icon, CTABrokerDB.icon);
	UIDropDownMenu_JustifyText(CTABroker.DDM.Icon, "LEFT");
	CTABroker.DDM.Icon.Title = CTABroker.DDM.Icon:CreateFontString(nil, "OVERLAY");
	CTABroker.DDM.Icon.Title:SetFontObject("GameFontHighlight");
	CTABroker.DDM.Icon.Title:SetPoint("LEFT", CTABroker.DDM.Icon, "RIGHT", 10, 0);
	CTABroker.DDM.Icon.Title:SetText(L["iconanchor"]);	
end

function CTABrokerFunction:DDMRealmSelection_InitializeTooltip(self, level)
	for index, value in ipairs(anchorpoint) do
		wipe(info);
		info.isNotRadio = true;
		info.text = value;
		info.value = value;
		info.func = function(self)
			CTABrokerDB.tooltip = anchorpoint[index];
			UIDropDownMenu_SetText(CTABroker.DDM.Tooltip, CTABrokerDB.tooltip);
			end
		UIDropDownMenu_AddButton(info, level);
	end
end

function CTABrokerFunction:DDMRealmSelection_InitializeIcon(self, level)
	for index, value in ipairs(anchorpoint) do
		wipe(info);
		info.isNotRadio = true;
		info.text = value;
		info.value = value;
		info.func = function(self)
			CTABrokerDB.icon = anchorpoint[index];
			UIDropDownMenu_SetText(CTABroker.DDM.Icon, CTABrokerDB.icon); 
			end
		UIDropDownMenu_AddButton(info, level);
	end
end

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Gestion de la sauvegarde  --------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

CTABroker.Core = CreateFrame("FRAME");
CTABroker.Core:RegisterEvent("ADDON_LOADED");
CTABroker.Core:RegisterEvent("PLAYER_ENTERING_WORLD");
function CTABroker.Core:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "CTABroker" then	
		if CTABrokerDB == nil then
			CTABrokerDB = {
				version = version,
				anchortop = 600,
				anchorleft = 600,
				sound = true,
				size = 50,
				tooltip = "BOTTOMLEFT",
				icon = "TOPLEFT",
				};
		end
		if CTABrokerDB.version < 1.01 then
			CTABrokerDB = table.wipe(CTABrokerDB);
			CTABrokerDB = {
				version = version,
				anchortop = 600,
				anchorleft = 600,
				sound = true,
				size = 50,
				tooltip = "BOTTOMLEFT",
				icon = "TOPLEFT",
				};	
		end
		CTABroker.version = version;
		--Détection de la langue
		if (GetLocale() == "frFR") then
			L = Lfrench;		
		else
			L = Lenglish;
		end	
		CTABrokerFunction:Main();
		CTABroker.Core:RegisterEvent("LFG_UPDATE_RANDOM_INFO");	
	end
	
	if event == "PLAYER_ENTERING_WORLD" then	
		if UnitFactionGroup("player") == "Alliance" then
			Sounds = SoundsA;
		else
			Sounds = SoundsH;		
		end
		CTABroker.Core:UnregisterEvent("PLAYER_ENTERING_WORLD");
	end
	
	if event == "LFG_UPDATE_RANDOM_INFO" then	
		--Scanning
		for key, value in pairs(DungeonsId) do
			CTABrokerFunction:Checking(key);
		end
		--Affichage
		CTABrokerFunction:Display();
	end
end
CTABroker.Core:SetScript("OnEvent", CTABroker.Core.OnEvent);


